-- The stat priority variable (too late to change the name)
StatPriorityTracker_Retail = "Empty"


-- Default Settings
isThePriorityFrameHidden = 1
SPTSetting_StickyOrLooseMainFrame = "sticky" -- loose
SPTSetting_MainFrameLength = "large" -- "small"


-- Settings Panel
SPT = {};
SPT.panel = CreateFrame("Frame", "SPTSettingsPanel", UIParent, BackdropTemplateMixin and "BackdropTemplate"); -- Register in the Interface Addon Options GUI
SPT.panel.name = "Stat Priority Tracker"; -- Set the name for the Category for the Options Panel
InterfaceOptions_AddCategory(SPT.panel) -- Add the panel to the Interface Options
SPT.panel.introText = SPT.panel:CreateFontString(nil, "ARTWORK")
SPT.panel.introText:SetFont("Fonts\\FRIZQT__.TTF", 11)
SPT.panel.introText:SetText("\nStatPriorityTracker_Retail 0.1.2b\n\nThis is where you can enter your Stat Priority.\nPress 'Okay' to confirm, or 'Cancel' to leave without saving changes.\n\nIf you made a mistake (and haven't saved yet), hit 'Cancel' and type '/reload'.\nThis will revert the data to the previously-saved version.\n\nExtra settings are temporarily disabled.")
SPT.panel.introText:SetTextColor(1, 1, 1)
SPT.panel.introText:SetAllPoints(true)
SPT.panel.introText:SetJustifyH("CENTER")
SPT.panel.introText:SetJustifyV("TOP")

  -- The new input box (in the Settings panel)
local fdd = CreateFrame("Button", "StatPriorityEditBox", SPT.panel, BackdropTemplateMixin and "BackdropTemplate")	
fdd:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", tile = true, tileSize = 16, insets = {left = 0, right = 0, top = 0, bottom = 0},})
fdd:SetBackdropColor(0, 0, 0)
fdd:SetPoint("CENTER", -300)
fdd:SetSize(550, 280)
fdd.Text = CreateFrame("EditBox", nil, fdd, BackdropTemplateMixin and "BackdropTemplate")
fdd.Text:SetPoint("TOPRIGHT", -10, -10)
fdd.Text:SetPoint("BOTTOMLEFT", 10, 10)
fdd.Text:SetMultiLine(true)
fdd.Text:SetMaxLetters(99999)
fdd.Text:SetFontObject(GameFontNormal)
fdd.Text:SetAutoFocus(false)


-- Settings subpanel 1
SPT.childpanel1 = CreateFrame("Frame", "SPTSettingsChildOne", SPT.panel, BackdropTemplateMixin and "BackdropTemplate");
SPT.childpanel1.name = "Extra Settings (Inactive)";
SPT.childpanel1.parent = SPT.panel.name; -- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
InterfaceOptions_AddCategory(SPT.childpanel1); -- Add the child to the Interface Options


-- Subpanel 1 options
  -- isThePriorityFrameHidden
--[[
checkBox_isThePriorityFrameHidden = CreateFrame("CheckButton", "checkBox_isThePriorityFrameHidden", SPT.childpanel1, "ChatConfigCheckButtonTemplate");
checkBox_isThePriorityFrameHidden:SetPoint("TOPLEFT", 20, -30);
checkBox_isThePriorityFrameHiddenText:SetText("Open by default");
checkBox_isThePriorityFrameHidden.tooltip = "Tick this if you want the stat priority frame to be activated by default.";
checkBox_isThePriorityFrameHidden:SetScript("OnClick", 
  function()
	if checkBox_isThePriorityFrameHidden:GetChecked() = true then
		--do
	else
		--do
	end
  end
);
]]--

  -- SPTSetting_StickyOrLooseMainFrame
checkBox_StickyOrLooseMainFrame = CreateFrame("CheckButton", "checkBox_StickyOrLooseMainFrame", SPT.childpanel1, "ChatConfigCheckButtonTemplate");
checkBox_StickyOrLooseMainFrame:SetPoint("TOPLEFT", 20, -60);
checkBox_StickyOrLooseMainFrameText:SetText("Stick to the character frame (requires /reload) [CURRENTLY DOESN'T WORK]");
checkBox_StickyOrLooseMainFrame.tooltip = "Tick this if you want the stat priority frame to have no gap to the left.";
checkBox_StickyOrLooseMainFrame:SetScript("OnClick", 
  function()
	if checkBox_StickyOrLooseMainFrame:GetChecked() == true then
		SPTSetting_StickyOrLooseMainFrame = "sticky"
		checkBox_StickyOrLooseMainFrame:SetChecked(true)
	else
		SPTSetting_StickyOrLooseMainFrame = "loose"
		checkBox_StickyOrLooseMainFrame:SetChecked(false)
	end
  end
);

  -- SPTSetting_MainFrameLength
checkBox_MainFrameLength = CreateFrame("CheckButton", "checkBox_MainFrameLength", SPT.childpanel1, "ChatConfigCheckButtonTemplate");
checkBox_MainFrameLength:SetPoint("TOPLEFT", 20, -90);
checkBox_MainFrameLengthText:SetText("Large frame (requires /reload) [CURRENTLY DOESN'T WORK]");
checkBox_MainFrameLength.tooltip = "Tick this if you want the frame to be large, untick if you want it to be thinner.";
checkBox_MainFrameLength:SetScript("OnClick", 
  function()
	if checkBox_MainFrameLength:GetChecked() == true then
		SPTSetting_MainFrameLength = "large"
		checkBox_MainFrameLength:SetChecked(true)
	else
		SPTSetting_MainFrameLength = "thin"
		checkBox_MainFrameLength:SetChecked(false)
	end
  end
);


-- Getting the player's class to display it
function getPlayerInfo()
    playerClass, englishClass = UnitClass("player");
    playerClassName = playerClass
end
getPlayerInfo()


-- Main frame
local f=CreateFrame("Frame", "ThePriorityFrame", PaperDollFrame, "BasicFrameTemplateWithInset", BackdropTemplateMixin and "BackdropTemplate") --Create a frame
f:SetFrameStrata("TOOLTIP") --Set its strata
f:SetHeight(422) --Give it height
f:SetWidth(220) --and width -- old 200
f:SetPoint("TOPRIGHT", PaperDollFrame, "TOPRIGHT", 225, 0) -- 190
ThePriorityFrame:Hide()
isThePriorityFrameHidden = 1
f:SetScript("OnHide", function(self, arg1)
	--isThePriorityFrameHidden = 1
end)

--[[
-- Button to show/hide
local frame = CreateFrame("Button", "ThePriorityButton", PaperDollFrame, UIPanelButtonTemplate)
frame:SetPoint("CENTER", PaperDollFrame, "CENTER", 115, -230, 0, 0) -- 105,250 top
frame:SetSize(58, 35)
frame:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight")
frame:SetNormalTexture("Interface\\PaperDollInfoFrame\\UI-Character-ActiveTab", 90)
frame.prioriName = frame:CreateFontString(nil, "ARTWORK")
frame.prioriName:SetFont("Fonts\\FRIZQT__.TTF", 11)
frame.prioriName:SetText("SPT >")
frame.prioriName:SetTextColor(0.85, 0.70, 0)
frame.prioriName:SetAllPoints(true)
frame.prioriName:SetJustifyH("CENTER")
frame.prioriName:SetJustifyV("CENTER")
frame:SetScript("OnClick", function(self, arg1)
    PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
    if isThePriorityFrameHidden == 1 then
        ThePriorityFrame:Show()
        frame.prioriName:SetText("< SPT")
        frame.prioriName:SetTextColor(255,255,255)
        isThePriorityFrameHidden = 0
    elseif isThePriorityFrameHidden == 0 then
        ThePriorityFrame:Hide()
        frame.prioriName:SetText("SPT >")
        frame.prioriName:SetTextColor(0.85, 0.70, 0)
        isThePriorityFrameHidden = 1
    end
end)
frame:SetScript("OnMouseDown", function(self, arg1)
    frame:SetSize(56, 25)
end)
frame:SetScript("OnMouseUp", function(self, arg1)
    frame:SetSize(58, 27)
end)
]]--

-- Button that is shown in the CharacterFrame
local frame = CreateFrame("Button", "ThePriorityButton", CharacterStatsPane.AttributesCategory, UIPanelButtonTemplate)
frame:SetPoint("RIGHT", CharacterStatsPane.AttributesCategory, "RIGHT", -20, 0)
frame:SetSize(20, 20)
frame:SetHighlightTexture("Interface\\ICONS\\misc_arrowright.blp")
frame:SetNormalTexture("Interface\\ICONS\\misc_arrowright.blp")
frame.prioriName = frame:CreateFontString(nil, "ARTWORK") --Create a FontString to display text
frame.prioriName:SetFont("Fonts\\FRIZQT__.TTF", 12) --Set the font and size
frame.prioriName:SetTextColor(120,120,0) --Set the text colour
frame.prioriName:SetAllPoints(true)
frame.prioriName:SetJustifyH("CENTER")
frame.prioriName:SetJustifyV("CENTER")
--frame.prioriName:SetText(">")
frame:SetScript("OnClick", function(self, arg1)
    PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
    if isThePriorityFrameHidden == 1 then
        ThePriorityFrame:Show()
        frame:SetHighlightTexture("Interface\\ICONS\\misc_arrowleft.blp")
        frame:SetNormalTexture("Interface\\ICONS\\misc_arrowleft.blp")
        isThePriorityFrameHidden = 0
    elseif isThePriorityFrameHidden == 0 then
        ThePriorityFrame:Hide()
        frame:SetHighlightTexture("Interface\\ICONS\\misc_arrowright.blp")
        frame:SetNormalTexture("Interface\\ICONS\\misc_arrowright.blp")
        isThePriorityFrameHidden = 1
    end
end)
frame:SetScript("OnMouseDown", function(self, arg1)
    frame:SetSize(17, 17)
end)
frame:SetScript("OnMouseUp", function(self, arg1)
    frame:SetSize(20, 20)
end)


-- Stuff inside the main frame
  -- Title
f.title = f:CreateFontString(nil, "OVERLAY");
f.title:SetFontObject("GameFontHighlight");
f.title:SetPoint("CENTER", f.TitleBg, "CENTER", 5, 0);
f.title:SetText("Stat Priority Tracker");

  -- Icon that is shows at the top of the frame
f.icon = CreateFrame("Frame","ThePriorityFrameClassIcon", ThePriorityFrame, BackdropTemplateMixin and "BackdropTemplate")
f.icon = f:CreateTexture(nil,"CENTER"); -- create texture as child of myframe
f.icon:SetHeight(30)
f.icon:SetWidth(30)
f.icon:SetPoint("CENTER", ThePriorityFrame, "TOP", 0, -50, 0, 0)
local _,class = UnitClass("player"); -- get non-localized class name
f.icon:SetTexture("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES"); -- this is the image containing all class icons
local coords = CLASS_ICON_TCOORDS[class]; -- get the coordinates of the class icon we want
f.icon:SetTexCoord(unpack(coords)); -- cut out the region with our class icon according to coords

  -- The class name
f.className = f:CreateFontString(nil, "ARTWORK") --Create a FontString to display text
f.className:SetFont("Fonts\\FRIZQT__.TTF", 13) --Set the font and size
f.className:SetTextColor(1, 1, 1) --Set the text colour
f.className:SetPoint("TOP", ThePriorityFrame, "TOP", 0, -70, 0, 0)
f.className:SetJustifyH("CENTER")
f.className:SetJustifyV("TOP")
f.className:SetText(playerClassName)

  -- The class icon
f.statPriority = f:CreateFontString(nil, "ARTWORK") --Create a FontString to display text
f.statPriority:SetFont("Fonts\\FRIZQT__.TTF", 11) --Set the font and size
f.statPriority:SetTextColor(1, 1, 1) --Set the text colour
f.statPriority:SetAllPoints(true)
f.statPriority:SetJustifyH("CENTER")
f.statPriority:SetJustifyV("CENTER", -20)

  -- The Settings button
local settingsButton = CreateFrame("Button", "TheSettingsButton", ThePriorityFrame, UIPanelButtonTemplate)
settingsButton:SetPoint("CENTER",ThePriorityFrame,"TOP", 0, -405, 0, 0)
settingsButton:SetSize(220, 50)
settingsButton:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight")
--settingsButton:SetNormalTexture("Interface\\PaperDollInfoFrame\\UI-Character-ActiveTab")
settingsButton.btnTxt = settingsButton:CreateFontString(nil, "ARTWORK")
settingsButton.btnTxt:SetFont("Fonts\\FRIZQT__.TTF", 12.5)
settingsButton.btnTxt:SetText("Settings")
settingsButton.btnTxt:SetTextColor(153, 115, 0)
settingsButton.btnTxt:SetAllPoints(true)
settingsButton.btnTxt:SetJustifyH("CENTER")
settingsButton.btnTxt:SetJustifyV("CENTER")
settingsButton:SetScript("OnMouseUp", function(self, arg1)
    InterfaceOptionsFrame_OpenToCategory(SPT.panel);
    InterfaceOptionsFrame_OpenToCategory(SPT.panel); -- Twice due to Blizzard's own bug
end)


-- Function to set and save the priority
function setThePriority()
	if rawPriority == "" then
		C_Timer.After(1, function()
			f.statPriority:SetText(tostring(StatPriorityTracker_Retail))
			--f.statPriority:SetText("cochonnerie")
			fdd.Text:SetText(tostring(StatPriorityTracker_Retail))
		end)
	else
		--fixedPriority1 = string.gsub(rawPriority, ">", "\n>\n")
		fixedPriority1 = rawPriority
		--fixedPriority2 = string.gsub(fixedPriority1, "/", " = ")
		--fixedPriority3 = string.gsub(fixedPriority2, "=", "\n=\n")
		--fixedPriority4 = string.gsub(fixedPriority3, "<", "\n<\n")
		--fixedPriority5 = string.gsub(fixedPriority4, "  ", "\n\n")
		--fixedPriority6 = string.gsub(fixedPriority5, ", ", "\n\n")
		--fixedPriority7 = string.gsub(fixedPriority6, ",", "\n\n")
		--fixedPriority8 = string.gsub(fixedPriority7, "\n ", "\n")
		--fixedPriority9 = string.gsub(fixedPriority8, " \n", "\n")
		--fixedPriority10 = string.gsub(fixedPriority9, " \n ", "\n")
		--fixedPriority11 = string.gsub(fixedPriority10, "\n", "\n")
		--playerStatPriority = string.gsub(fixedPriority11, " %(", "\n%(")
		playerStatPriority = fixedPriority1
		StatPriorityTracker_Retail = playerStatPriority -- initial value (will be overwritten when/if SavedVariables load)
		C_Timer.After(1, function()
			f.statPriority:SetText(tostring(StatPriorityTracker_Retail))
			--print("Under this should be the Stat Priority: ")
			--print(tostring(StatPriorityTracker_Retail))
		end)
		--tinsert(StatPriorityTracker_Retail)
	end
end


-- Activate upon load
C_Timer.After(1, function()
	setThePriority()
end)
--C_Timer.After(1, function()
--	fdd.Text:SetText(tostring(StatPriorityTracker_Retail))
--end)


-- Edit things according to saved settings
  -- Saved button states
C_Timer.After(1, function(setSavedStuff)
	-- sticky/loose
	if SPTSetting_StickyOrLooseMainFrame == "sticky" then
		if SPTSetting_MainFrameLength == "large" then
			--
		else
			f:SetPoint("TOPRIGHT", PaperDollFrame, "TOPRIGHT", 128, -14.5)
		end
		checkBox_StickyOrLooseMainFrame:SetChecked(true)
	else
		if SPTSetting_MainFrameLength == "large" then
			f:SetPoint("TOPRIGHT", PaperDollFrame, "TOPRIGHT", 250, -14.5)
		else
			--
		end
		checkBox_StickyOrLooseMainFrame:SetChecked(false)
	end

	-- large/thinm
	if SPTSetting_MainFrameLength == "large" then
		checkBox_MainFrameLength:SetChecked(true)
	else
		checkBox_MainFrameLength:SetChecked(false)
		f:SetWidth(160)
		settingsButton:SetSize(130, 30)
	end
end)


-- The settings "Okay" button
function SPT.panel.okay()
 xpcall(function()
	rawPriority = fdd.Text:GetText()
	fdd.Text:ClearFocus()
	setThePriority()
 end, geterrorhandler())
end


-- The settings "Cancel" button
function SPT.panel.cancel()
 xpcall(function()
	--print("SPT: Pressed 'cancel'. Changes will not be saved.")
 end, geterrorhandler())
end